<template>
  <l-map
      class="map"
      ref="map"
      v-model:zoom="zoom"
      v-model:center="center"
      :options="{attributionControl: false}">
    <l-tile-layer
        url="http://tile.osm.ch/osm-swiss-style/{z}/{x}/{y}.png"
        layer-type="base"
        name="Swiss Style OSM"
    ></l-tile-layer>
    <l-geo-json :geojson="geojson"></l-geo-json>
    <l-control-attribution
        position="bottomright"
        :prefix="attribution"
    ></l-control-attribution>
  </l-map>
</template>

<script>

import {
  LControlAttribution,
  LGeoJson,
  LMap,
  LTileLayer
} from "@vue-leaflet/vue-leaflet";

import tableTennisGeoJson from "/src/assets/table_tennis_zh.geojson";

export default {
  name: "MapComponent",
  components: {
    LMap,
    LTileLayer,
    LGeoJson,
    LControlAttribution
  },
  data() {
    return {
      zoom: 10,
      center: [47.41330, 8.65639],
      geojson: null,
      attribution: "Data &copy " +
          "<a href='http://openstreetmap.org/copyright'>OpenStreetMap</a> " +
          "contributors <a href='https://opendatacommons.org/licenses/odbl/'>ODbL</a> | " +
          "Map by <a href='https://sosm.ch/'>SOSM</a> | " +
          "<a id='problem-attribution' " +
          "href='http://www.openstreetmap.org/fixthemap?" +
          "lat=47.41330&lon=8.65639&zoom=18'>Report a problem</a>",
    };
  },
  async created() {
    this.geojson = tableTennisGeoJson;
  },
  watch: {
    zoom() {
      this.updateProblemLink();
    },
    center() {
      this.updateProblemLink();
    }
  },
  methods: {
    updateProblemLink() {
      this.$el.querySelector("#problem-attribution")
          .href = "http://www.openstreetmap.org/fixthemap?" +
          `lat=${this.center.lat}&lon=${this.center.lng}` +
          `&zoom=${this.zoom}`;
    }
  },
}
</script>

<style scoped>

</style>
